"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncYamlFileAdapter = exports.YamlFileAdapter = void 0;
const fs = __importStar(require("fs"));
const yaml = __importStar(require("js-yaml"));
const path = __importStar(require("path"));
const fs_help_1 = require("./fs_help");
class YamlFileAdapter {
    constructor(path) {
        this.path = path;
    }
    save(data) {
        return new Promise((rs, rj) => fs_help_1.mkdirs(path.dirname(this.path)).then(() => fs.writeFile(this.path, yaml.dump(data), err => {
            if (err)
                rj(err);
            else
                rs();
        })));
    }
    load() {
        return new Promise((rs, rj) => {
            fs.exists(this.path, exists => {
                if (exists) {
                    fs.readFile(this.path, (err, data) => {
                        if (err)
                            rj(err);
                        else
                            rs(yaml.load(data.toString()));
                    });
                }
                else
                    rs({});
            });
        });
    }
}
exports.YamlFileAdapter = YamlFileAdapter;
class SyncYamlFileAdapter {
    constructor(path) {
        this.path = path;
    }
    save(data) {
        fs_help_1.mkdirsSync(path.dirname(this.path));
        fs.writeFileSync(this.path, yaml.dump(data));
    }
    load() {
        if (fs.existsSync(this.path))
            return yaml.load(fs.readFileSync(this.path).toString());
        return {};
    }
}
exports.SyncYamlFileAdapter = SyncYamlFileAdapter;
//# sourceMappingURL=src/sourcemaps/yaml_adapter.js.map